import os
from nanoid import generate

from flask_testing import TestCase, LiveServerTestCase

from capsulflask import create_app
from capsulflask.db import get_model


class BaseSharedTestCase(object):
    def create_app(self):
        # Use default connection paramaters
        os.environ['POSTGRES_CONNECTION_PARAMETERS'] = "host=localhost port=5432 user=postgres password=dev dbname=capsulflask_test"
        os.environ['TESTING'] = '1'
        os.environ['SPOKE_MODEL'] = 'mock'
        os.environ['HUB_MODEL'] = 'mock'
        return create_app()

    def setUp(self):
        pass

    def tearDown(self):
        pass


class BaseTestCase(BaseSharedTestCase, TestCase):
    def _login(self, user_email):
        get_model().login(user_email)
        with self.client.session_transaction() as session:
            session['account'] = user_email
            session['csrf-token'] = generate()


class BaseLiveServerTestCase(BaseSharedTestCase, LiveServerTestCase):
    pass
